﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Diagnostics;
using FDK;

namespace StrokeStyleT
{
	class CAct演奏ビッグファイア : CActivity
	{
		public bool b発火する( Cチップ chip )
		{
			return
				chip.eチップ == Eチップ.LeftCrash ||
				chip.eチップ == Eチップ.RightCrash ||
//				chip.eチップ == Eチップ.Splash ||	発火しない。
//				chip.eチップ == Eチップ.Ride ||			〃
//				chip.eチップ == Eチップ.Ride_Cup ||		〃
				chip.eチップ == Eチップ.China;
		}
		public void t発火()
		{
			// DirectShoe 再生開始

			if( this.BigFiles[this.n次の波 ].ds != null )
				this.BigFiles[ this.n次の波 ].ds.t最初から再生開始();


			// ローテーション

			this.n次の波 = ( this.n次の波 + 1 ) % n波の数;
		}
		
		public override void On活性化()
		{
			if( this.b活性化してる )
				return;

			this.BigFiles = new STBigFire[ n波の数 ];
			for( int i = 0; i < this.BigFiles.Length; i++ )
			{
				this.BigFiles[ i ].ds = Global.t失敗してもスキップ可能なDirectShowを生成する( Global.Theme.tファイルパス( @"ScreenPlay big fire.wmv" ), Global.App.Window.Handle );
				this.BigFiles[ i ].tx = null;	// Texture は DirectShow の再生後に作成する。
				this.BigFiles[ i ].bテクスチャの作成に失敗した = false;
			}

			base.On活性化();
		}
		public override void On非活性化()
		{
			if( this.b活性化してない )
				return;


			// 先に Managedリソースを解放する。

			base.On非活性化();

	
			// BigFires[] を解放。

			for( int i = 0; i < n波の数; i++ )
			{
				C共通.tDisposeする( ref this.BigFiles[ i ].ds );
				C共通.tDisposeする( ref this.BigFiles[ i ].tx );	// OnManagedリソースの解放() で行われるが、念のため。
			}
			this.BigFiles = null;
		}
		public override void OnManagedリソースの作成()
		{
			if( this.b活性化してない )
				return;

			// 再生中である DirectShow のテクスチャを生成する。

			for( int i = 0; i < n波の数; i++ )
			{
				if( this.BigFiles[ i ].ds != null )
				{
					if( this.BigFiles[ i ].ds.eグラフの状態 == CDirectShow.Eグラフの状態.再生中 )
					{
						this.BigFiles[ i ].bテクスチャの作成に失敗した = false;
						this.BigFiles[ i ].tx = this.tテクスチャの作成( this.BigFiles[ i ].ds.n幅px, this.BigFiles[ i ].ds.n高さpx );
						if( this.BigFiles[ i ].tx == null )
							this.BigFiles[ i ].bテクスチャの作成に失敗した = true;
					}
				}
			}

			base.OnManagedリソースの作成();
		}
		public override void OnManagedリソースの解放()
		{
			if( this.b活性化してない )
				return;

			// 再生中である DirectShow のテクスチャを解放する。

			for( int i = 0; i < n波の数; i++ )
			{
				if( this.BigFiles[ i ].ds != null )
				{
					if( this.BigFiles[ i ].ds.eグラフの状態 == CDirectShow.Eグラフの状態.再生中 )
						C共通.tDisposeする( ref this.BigFiles[ i ].tx );
				}
			}

			base.OnManagedリソースの解放();
		}
		public override void On描画()
		{
			if( this.b活性化してない )
				return;

			for( int i = 0; i < n波の数; i++ )
			{
				if( this.BigFiles[ i ].ds == null ||
					this.BigFiles[ i ].ds.eグラフの状態 != CDirectShow.Eグラフの状態.再生中 )
					continue;

				try
				{
					// テクスチャの生成がまだなら生成する。

					if( this.BigFiles[ i ].tx == null &&
						this.BigFiles[ i ].bテクスチャの作成に失敗した == false )
					{
						this.BigFiles[ i ].tx = this.tテクスチャの作成( this.BigFiles[ i ].ds.n幅px, this.BigFiles[ i ].ds.n高さpx );
						if( this.BigFiles[ i ].tx == null )
							this.BigFiles[ i ].bテクスチャの作成に失敗した = true;	// エラーメッセージの表示は1回だけ。
					}

					// DirectShow のイメージを取得して描画する。

					if( this.BigFiles[ i ].tx != null )
					{
						this.BigFiles[ i ].ds.t現時点における最新のスナップイメージをTextureに転写する( this.BigFiles[ i ].tx );
						this.BigFiles[ i ].tx.t2D描画(
							Global.App.D3D9Device,
							0,
							(int) ( Global.Theme.LogicalDisplaySize.Height - ( this.BigFiles[ i ].tx.sz画像サイズ.Height * this.BigFiles[ i ].tx.vc拡大縮小倍率.Y ) ) );
					}
				}
				catch
				{
					// DirectShow 側のスレッドが準備できてなければ例外が出るので、ここで黙殺しておく。
				}
			}
		}
		
		#region [ protected ]
		//-----------------
		protected struct STBigFire
		{
			public CDirectShow ds;		// 動画と
			public CTexture tx;	// その動画を表示するテクスチャ
			public bool bテクスチャの作成に失敗した;
		}
		STBigFire[] BigFiles = null;

		protected const int n波の数 = 3;
		protected int n次の波 = 0;

		protected CTexture tテクスチャの作成( int width, int height )
		{
			var tx = Global.tテクスチャを生成する( width, height );
			if( tx != null )
			{
				tx.b加算合成 = true;
				tx.vc拡大縮小倍率.X = (float) Global.Theme.LogicalDisplaySize.Width / width;
				tx.vc拡大縮小倍率.Y = (float) Global.Theme.BigFireHeight / height;
			}
			return tx;
		}
		//-----------------
		#endregion
	}
}
